/* 1. 1.    
	(Zweigstellen) Geben Sie alle Zweigstellen („name“ und „anschrift“) zusammen mit ihren 
	Angestellten („pid“, „vname“ und „nname“) aus. Vermerken Sie in einer zusaetzlichen Spalte, 
	ob es sich bei dem Angestellten um den Leiter der Zweigstelle handelt. Benennen Sie diese 
	neue Spalte mit „position“. Sortieren Sie die Ausgabe nach der Zweigstelle und - 
	falls dieser gleich ist - nach dem Namen des Angestellten. */

/* Abfrage */
SELECT z.name, z.anschrift, p.pid, p.vname, p.nname, (CASE WHEN (z.leiter = p.pid) 
	THEN 'Leiter' ELSE 'Angestellter' END) AS position
FROM Zweigstelle z JOIN Mitarbeiter m ON (z.name = m.zweigstelle) 
	JOIN Person p ON (m.pid = p.pid)
ORDER BY z.name, position DESC, p.nname, p.vname;

/* 1. 2.
	(Belesenster Mitarbeiter) Geben Sie den (oder die) Mitarbeiter („vname“, „nname“) 
	mit den meisten Entlehnungen zusammen mit der Anzahl der Entlehnungen aus.*/

/* Abfrage */
SELECT p.vname, p.nname, COUNT(*) 
FROM Person p JOIN Entlehnkarte k ON (p.pid = k.person) JOIN Entlehnung e ON (k.nr = e.entlehnkarte) 
	JOIN entlehnt t ON (e.eid = t.eid) 
WHERE p.pid IN (SELECT pid FROM Mitarbeiter) 
GROUP BY p.pid, p.vname, p.nname 
HAVING COUNT(*) >= ALL(SELECT COUNT(*) 
	FROM Person p JOIN Entlehnkarte k ON (p.pid = k.person) JOIN Entlehnung e ON (k.nr = e.entlehnkarte) 
		JOIN entlehnt t ON (e.eid = t.eid) 
	WHERE p.pid IN (SELECT pid FROM Mitarbeiter) 
	GROUP BY p.pid);


/* 1. 3.
	(Lese-Statisitk) Geben Sie eine Liste ALLER Entlehnkarten-Besitzer (Nummer der Entlehnkarte, 
	Vor- und Nachname des Besitzers) zusammen mit der Summe der Seiten aus, die jeder Besitzer
	bereits gelesen hat. Gehen Sie davon aus, dass jedes ausgeliehene Buch tatsaechlich in seinem 
	vollem Umfang gelesen wird. Fuer Entlehnkarten-Besitzer, die bisher noch keine Buecher bzw. ueberhaupt
	noch nichts ausgeliehen haben, soll der Wert '0' ausgegeben werden. */

/* Abfrage */

SELECT k.nr, p.vname, p.nname, coalesce(sum(b.umfang), '0') AS gesamtseiten 
FROM entlehnung e JOIN entlehnt t ON (e.eid = t.eid) JOIN buecher b ON (t.mediennr = b.mediennr) 
	RIGHT OUTER JOIN (entlehnkarte k JOIN person p ON (p.pid = k.person)) ON (k.nr = e.entlehnkarte) 
GROUP BY k.nr, p.vname, p.nname;


/* 2.
	Waehlen Sie per Hand ein Themengebiet aus, das Teil einer hierarchischen Ordnung ist. Schreiben Sie eine 
	Query, die dieses Themengebiet ("themenid" und "name") ausgibt sowie rekursiv alle Oberthemen in dieser
	Hierarchie. Passen Sie die Tupel in Ihrer Datenbank so an, dass es zu dem von Ihnen ausgewaehlten 
	Themengebiet mindestens zwei Ebenen uebergeordneter Themengebieten gibt. Achten Sie darauf, dass Ihre 
	Daten keine Schleife enthalten, da ansonsten die Abfrage fehlschlaegt. */

/* Abfrage */
/* Hier: Waehle Themengebiet '6' */

WITH RECURSIVE themenserie (oberthema) AS (
   SELECT unterthema FROM untergeordnet WHERE unterthema = '6'
   UNION ALL
   SELECT untergeordnet.oberthema
   FROM themenserie, untergeordnet
   WHERE themenserie.oberthema = untergeordnet.unterthema)
SELECT oberthema AS themenhierarchie, name FROM themenserie s JOIN Themengebiet t ON (s.oberthema = t.themenid);

/* 3. 1.
	Waehlen Sie per Hand eine Zweigstelle aus und geben Sie alle Themengebiete ("themenid", "name") aus, zu 
	denen es in dieser Zweigstelle kein einziges Exemplar gibt. */

/* Abfrage */
/* Hier: Waehle Zweigstelle 'Zweigstelle 1' */
	
SELECT * FROM Themengebiet 
WHERE themenid NOT IN 
	(SELECT themenid FROM zugeordnet NATURAL JOIN Exemplar 
		WHERE zweigstelle = 'Zweigstelle 1');

/* 3. 2. 
	Geben Sie zu jeder Zweigstelle ("name", "anschrift") jene Mitarbeiter aus ("pid", "vname", "nname"), die 
	in dieser Zweigstelle das hoechste Gehalt beziehen. Ordnen Sie das Ergebnis nach der Zweigstelle. */

/* Abfrage */

SELECT m.zweigstelle, z.anschrift, m.pid, p.vname, p.nname 
FROM Mitarbeiter m JOIN Person p ON (m.pid = p.pid) 
	JOIN Zweigstelle z ON (m.zweigstelle = z.name) 
WHERE m.gehalt = (SELECT MAX(gehalt) FROM Mitarbeiter WHERE zweigstelle = m.zweigstelle) 
ORDER BY m.zweigstelle;


/* 4.
	Schreiben Sie Befehle zum Erzeugen und Loeschen einer View ("kuenstler_statistik_view"), welche fuer ALLE
	Kuenstler ("kid", "vname", "nname")...
	- die Anzahl der Buecher ausgibt, die er alleine verfasst hat,
	- die Anzahl der Buecher ausgibt, die er mit anderen Autoren gemeinsam geschrieben hat,
	- UND die Anzahl der Filme ausgibt, bei denen er Regie gefuehrt hat. 
	Hat ein Kuenstler kein Buch alleine verfasst bzw. kein Buch gemeinsam geschrieben bzw. in keinem 
	Film Regie gefuehrt, so soll der Wert "0" eingetragen werden. Ordnen Sie das Ergebnis nach der 
	Kuenstler-ID ("kid").*/

CREATE VIEW kuenstler_statistik_view AS 
	SELECT k.kid, k.vname, k.nname, a.alleine, b.zusammen, c.regie 
	FROM kuenstler k NATURAL JOIN (SELECT k1.kid, COUNT(v1.mediennr) AS alleine 
		FROM kuenstler k1 LEFT OUTER JOIN verfasst v1 ON (k1.kid = v1.kid AND v1.mediennr IN 
			(SELECT mediennr FROM verfasst GROUP BY mediennr HAVING COUNT(*) = 1)) GROUP BY k1.kid) a 
		NATURAL JOIN (SELECT k2.kid, COUNT(v2.mediennr) AS zusammen FROM kuenstler k2 LEFT OUTER JOIN 
			verfasst v2 ON (k2.kid = v2.kid AND v2.mediennr IN (SELECT mediennr FROM verfasst 
			GROUP BY mediennr HAVING COUNT(*) >1)) GROUP BY k2.kid) b 
		NATURAL JOIN (SELECT k3.kid, COUNT(f.mediennr) AS regie FROM kuenstler k3 LEFT OUTER JOIN filme f 
			ON (k3.kid = f.regisseur) GROUP BY k3.kid) c 
	ORDER BY k.kid asc;

SELECT * FROM kuenstler_statistik_view;

DROP VIEW kuenstler_statistik_view;

/* Alternative Loesung:

CREATE VIEW kuenstler_statistik_view AS 
	SELECT k.kid, k.vname, k.nname, 
		(SELECT COUNT(v1.mediennr) FROM kuenstler k1 LEFT OUTER JOIN verfasst v1 ON (k1.kid = v1.kid AND v1.mediennr IN 
			(SELECT mediennr FROM verfasst GROUP BY mediennr HAVING COUNT(*) = 1)) where k1.kid = k.kid GROUP BY k1.kid) as alleine,
		(SELECT COUNT(v2.mediennr) AS zusammen FROM kuenstler k2 LEFT OUTER JOIN 
			verfasst v2 ON (k2.kid = v2.kid AND v2.mediennr IN (SELECT mediennr FROM verfasst 
			GROUP BY mediennr HAVING COUNT(*) >1)) where k2.kid = k.kid GROUP BY k2.kid) as zusammen,
		(SELECT COUNT(f.mediennr) AS regie FROM kuenstler k3 LEFT OUTER JOIN filme f 
			ON (k3.kid = f.regisseur) where k3.kid = k.kid GROUP BY k3.kid) as regie
	FROM kuenstler k
	ORDER BY k.kid asc;
	
SELECT * FROM kuenstler_statistik_view;

DROP VIEW kuenstler_statistik_view;

*/
